<template>
  <div id="lecture_from_bank_wrapper" class="bt-container">
    <h2>{{ $t('LECTURE_LIST.LECTURE_FROM_BANK') }}</h2>
    <div style="height: 10px;" />
    <el-tabs type="card" @tab-click="onClick('TAB_CHANGE')">
      <el-tab-pane :label="$t('ITEM_FROM_BANK.SRCH_LEC_NAME')">
        <el-input :placeholder="$t('ITEM_FROM_BANK.SRCH_LEC_NAME')" prefix-icon="el-icon-search" v-model="searchName" style="width: 300px;"></el-input>
        <el-button type="primary" @click="onClick('SEARCH_BY_NAME')">{{ $t('ITEM_FROM_BANK.SEARCH') }}</el-button>
        <el-button @click="onClick('INIT_RESULT')">{{ $t('ITEM_FROM_BANK.REFRESH') }}</el-button>
      </el-tab-pane>
      <el-tab-pane :label="$t('ITEM_FROM_BANK.SEARCH_GROUP')">
        <el-select v-model="selectGroup" :placeholder="$t('ITEM_FROM_BANK.SELECT_GROUP')">
          <el-option v-for="item in group" :key="item.group_id" :label="item.name" :value="item.group_id"></el-option>
        </el-select>
        <el-button type="primary" @click="onClick('SEARCH_BY_GROUP')">{{ $t('ITEM_FROM_BANK.SEARCH') }}</el-button>
        <el-button @click="onClick('INIT_RESULT')">{{ $t('ITEM_FROM_BANK.REFRESH') }}</el-button>
      </el-tab-pane>
      <el-tab-pane :label="$t('ITEM_FROM_BANK.SEARCH_KEYWORD')">
        <el-input :placeholder="$t('BANK.SEARCH_KEYWORD')" prefix-icon="el-icon-search" v-model="searchKey" style="width: 300px;"></el-input>
        <el-button @click="onClick('NEW_KEYWORD', searchKey)">{{ $t('ITEM_FROM_BANK.ADD_KEY') }}</el-button>
        <br />
        <div style="height: 10px;" />
        <el-tag v-for="(value, index) in searchKeywordList" :key="value" closable @close="deleteKeyword(index)" style="margin-right: 5px;">{{ value }}</el-tag>
        <el-button type="primary" @click="onClick('SEARCH_BY_KEYWORD')">{{ $t('ITEM_FROM_BANK.SEARCH') }}</el-button>
        <el-button @click="onClick('INIT_RESULT')">{{ $t('ITEM_FROM_BANK.REFRESH') }}</el-button>
      </el-tab-pane>
    </el-tabs>
    <div style="height: 50px;" />
    <el-table ref="multipleTable" :data="resultLectureList" style="width: 100%" @selection-change="handleSelectionChange" max-height="400">
      <el-table-column
        type="selection"
        width="55">
      </el-table-column>
      <el-table-column :label="$t('LECTURE_LIST.LECTURE_NAME')">
        <template slot-scope="scope">{{ scope.row.name }}</template>
      </el-table-column>
      <el-table-column :label="$t('BANK.GROUP')">
        <template slot-scope="scope">{{ scope.row.groupName }}</template>
      </el-table-column>
      <!--<el-table-column label="저작일">
        <template slot-scope="scope">{{ scope.row.createTime }}</template>
      </el-table-column>
      <el-table-column label="최종 수정일">
        <template slot-scope="scope">{{ scope.row.updateTime }}</template>
      </el-table-column>-->
    </el-table>
    <div style="height: 10px;" />
    <div style="text-align: right;">
      <el-button type="primary" @click="onClick('BRING_LECTURE')">{{ $t('ITEM_FROM_BANK.IMP_SLCT_LEC') }}</el-button>
      <router-link :to="`/a/teacher/NNclass/${classId}}`">
        <el-button @click="onClick('BACK')">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
      </router-link>
    </div>
  </div>
</template>

<script>
import bankService from '../../services/bankService';

export default {
  name: 'NLectureFromBank',
  data() {
    return {
      isAdd: false,
      searchName: '',
      selectGroup: '',
      searchKey: '',
      searchKeywordList: [],
      multipleSelection: [],
      group: [],
      resultLectureList: [],
      bankLectureList: [],
    };
  },
  computed: {
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.query.classId, 10);
    },
  },
  async mounted() {
    const vm = this;
    vm.isAdd = false;
    const res = await bankService.getBankLecture();
    res.data.lectureList.forEach((x) => {
      const lectureInfo = {};
      lectureInfo.name = x.name;
      lectureInfo.lectureId = x.lecture_id;
      /* const cr1 = x.created_at.substr(0, 10);
      const cr2 = x.created_at.substr(11, 8);
      lectureInfo.createTime = cr1.concat(' ', cr2);
      const up1 = x.updated_at.substr(0, 10);
      const up2 = x.updated_at.substr(11, 8);
      lectureInfo.updateTime = up1.concat(' ', up2); */
      lectureInfo.groupId = x.bank_group.group_id;
      lectureInfo.groupName = x.bank_group.name;
      vm.bankLectureList.push(lectureInfo);
    });
    vm.resultLectureList = vm.bankLectureList;
    // 내 그룹 받아오기
    const myg = await bankService.getMyGroup();
    vm.group = myg.data.groupList;
  },
  methods: {
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    async onClick(type) {
      const vm = this;
      switch (type) {
        // 탭 변경
        case 'TAB_CHANGE': {
          vm.searchName = '';
          vm.searchKey = '';
          vm.searchGroup = '';
          vm.searchKeywordList = [];
          vm.$refs.multipleTable.clearSelection();
          break;
        }
        // 강의명으로 검색
        case 'SEARCH_BY_NAME': {
          if (vm.searchName === '') {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.ENTER_CRS_NAME'),
              type: 'warning',
            });
            break;
          }
          vm.resultLectureList = [];
          const res = bankService.getBankLectureByName({
            name: vm.searchName,
          });
          res.then(function(sre) {  // eslint-disable-line
            sre.data.lectureList.forEach((x) => {
              const lectureInfo = {};
              lectureInfo.name = x.name;
              lectureInfo.lectureId = x.lecture_id;
              /* const cr1 = x.created_at.substr(0, 10);
              const cr2 = x.created_at.substr(11, 8);
              lectureInfo.createTime = cr1.concat(' ', cr2);
              const up1 = x.updated_at.substr(0, 10);
              const up2 = x.updated_at.substr(11, 8);
              lectureInfo.updateTime = up1.concat(' ', up2); */
              lectureInfo.groupId = x.bank_group.group_id;
              lectureInfo.groupName = x.bank_group.name;
              vm.resultLectureList.push(lectureInfo);
            });
          });
          break;
        }
        // 소속 그룹으로 검색
        case 'SEARCH_BY_GROUP': {
          if (vm.selectGroup === '') {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.SLCT_GRP'),
              type: 'warning',
            });
            break;
          }
          vm.resultLectureList = [];
          const res = bankService.getBankLectureByGroup({
            id: vm.selectGroup,
          });
          res.then(function(sre) {  // eslint-disable-line
            sre.data.lectureList.forEach((x) => {
              const lectureInfo = {};
              lectureInfo.name = x.name;
              lectureInfo.lectureId = x.lecture_id;
              /* const cr1 = x.created_at.substr(0, 10);
              const cr2 = x.created_at.substr(11, 8);
              lectureInfo.createTime = cr1.concat(' ', cr2);
              const up1 = x.updated_at.substr(0, 10);
              const up2 = x.updated_at.substr(11, 8);
              lectureInfo.updateTime = up1.concat(' ', up2); */
              lectureInfo.groupId = x.bank_group.group_id;
              lectureInfo.groupName = x.bank_group.name;
              vm.resultLectureList.push(lectureInfo);
            });
          });
          break;
        }
        // 검색할 키워드 추가
        case 'NEW_KEYWORD': {
          // 빈 키워드 입력
          if (vm.searchKey === '') {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.ENTER_KYWRD'),
              type: 'warning',
            });
            break;
          }
          // 키워드 추가시 중복 검사
          if (vm.searchKeywordList.includes(vm.searchKey) === true) {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.ALRDY_ADDED_KEY'),
              type: 'warning',
            });
            break;
          }
          // 중복이 아닐 경우 검색 목록에 추가
          vm.searchKeywordList.push(vm.searchKey);
          vm.searchKey = '';
          break;
        }
        // 입력한 키워드들로 검색
        case 'SEARCH_BY_KEYWORD': {
          // 키워드가 없으면 검색이 되지 않음
          if (vm.searchKeywordList.length === 0) {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.ADD_KEY'),
              type: 'warning',
            });
            break;
          }
          vm.resultLectureList = [];
          const res = bankService.getBankLectureByKeyword({
            keyArray: vm.searchKeywordList,
          });
          res.then(function(sre) {  // eslint-disable-line
            sre.data.lectureList.forEach((x) => {
              const lectureInfo = {};
              lectureInfo.name = x.name;
              lectureInfo.lectureId = x.lecture_id;
              /* const cr1 = x.created_at.substr(0, 10);
              const cr2 = x.created_at.substr(11, 8);
              lectureInfo.createTime = cr1.concat(' ', cr2);
              const up1 = x.updated_at.substr(0, 10);
              const up2 = x.updated_at.substr(11, 8);
              lectureInfo.updateTime = up1.concat(' ', up2); */
              lectureInfo.groupId = x.bank_group.group_id;
              lectureInfo.groupName = x.bank_group.name;
              vm.resultLectureList.push(lectureInfo);
            });
          });
          break;
        }
        // 검색 결과 초기화  & 선택 내용 초기화
        case 'INIT_RESULT': {
          vm.searchName = '';
          vm.selectGroup = '';
          vm.searchKey = '';
          vm.searchKeywordList = [];
          vm.resultLectureList = vm.bankLectureList;
          vm.$refs.multipleTable.clearSelection();
          break;
        }
        // 선택된 강의들 가져오기
        case 'BRING_LECTURE': {
          // 선택된 강의가 없을 경우
          if (vm.multipleSelection.length === 0) {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.NO_CRS_SLCTED'),
              type: 'warning',
            });
            break;
          }
          let i;
          for (i = 0; i < vm.multipleSelection.length; i += 1) {
            const x = vm.multipleSelection[i];
            // 강의 선택한 순서대로 하나씩 가져오기 - await 비동기 처리 190516
            await bankService.bankToLecture({ // eslint-disable-line
              lecture_id: x.lectureId,
              target_class_id: vm.classId,
            });
          }
          vm.$notify({
            title: vm.$t('NOTIFY.TITLE'),
            message: vm.$t('NOTIFY.SUCCESS_IMPR_CRS'),
            type: 'success',
          });
          break;
        }
        // 뒤로 가기
        case 'BACK': {
          break;
        }
        default: {
          break;
        }
      }
    },
    // 추가한 키워드 삭제
    deleteKeyword(arg) {
      const vm = this;
      vm.searchKeywordList.splice(arg, 1);
    },
  },
};
</script>

